#ifndef _LGSITERATIV_H_
#define _LGSITERATIV_H_

// Hilfsprogramme 
#include <iostream>
using namespace std;
#include <cstdlib>

void JacobiCSR(int* column_indices,double* entries,int* row_offsets,
	       double* x,double* b,int n,int itmax, double eps,int *it)
// Jacobi-Verfahren zum Loesen von Ax=b
// A\in R^{n,n} als CSR-Matrix gespeichert
// eps.. relative Genauigkeit
// itmax.. max Iterationszahl
// it.. benoetigte Iterationen (Ausgabe)
// x.. Start/Loesungsvektor (I/O)
{
  double* diag;
  double* w;
  double* r;
  double abbr,rw;
  int i;
  diag=(double*)malloc(n*sizeof(double));
  r=(double*)malloc(n*sizeof(double));
  w=(double*)malloc(n*sizeof(double));
  GenDiagCSR(column_indices,entries,row_offsets,diag,n);
  i=0;
  MatVecMulCSR(column_indices,entries,row_offsets,x,r,n);
  vdminus(n,r,1,b,1,r,1);  // r=A*x-b
  vddiv(n,r,1,diag,1,w,1);  // w=D^{-1}r
  dscapr(&rw,n,r,w);
  abbr=eps*eps*rw;
  cout <<"Iterationen  <r,w>"<<endl;
  while (i<itmax && abbr<rw)
    {
      i++;
      vdminus(n,x,1,w,1,x,1);
      MatVecMulCSR(column_indices,entries,row_offsets,x,r,n);
      vdminus(n,r,1,b,1,r,1);
      vddiv(n,r,1,diag,1,w,1);
      dscapr(&rw,n,r,w);
      cout<< i <<"    "<< rw <<endl;
    }
  *it=i;
  free(diag); 
  free(r);
  free(w);
}


#endif
